% A first test of the spectral regularization on texture images.
%  
% Here, I split the domain into several non-overlapping components
% to ensure that the obtimization was feasible.
%
% (c) Neil Birkbeck, 2010
function R=spectregtex(images)

[h, w, nchan, nimages] = size(images);
mask = zeros(h, w);

for i=1:size(images, 4),
  mask = mask | (images(:, :, 4, i) > 0);
end

I = find(mask);

R = zeros(h, w, 3);
nimages

for chan=1:3,
  X = zeros(length(I), nimages);
  P = zeros(size(X));

  for i=1:nimages,
    im = images(:,:,chan,i);
    X(:, i) = im(I);
    
    im = images(:,:,4,i) > 0;
    P(:, i) = im(I);
  end
  
  Zj = {};
  sp = 835;
  
  for j=1:sp:size(X,1),
    si = j:min(j+(sp-1), length(X));
    size(X)
    
    Z = spectreg(X(si,:) - repmat(sum(X(si,:).*P(si,:), 2)./sum(P(si,:), 2), [1, size(X(si,:), 2)]), P(si,:), [1.5]);
    Zj{(j - 1)/sp + 1} = Z{1};
    j
  end
  
  % Extract into Z, and add back the mean
  Z = [];
  for i=1:length(Zj),
    Z = cat(1, Z, Zj{i});
  end
  Z = Z + repmat(sum(X.*P, 2)./sum(P, 2), [1, size(X, 2)]);

  
  % Reconstruct
  for i=1:size(images, 4),
    c = zeros(h, w);
    c(I) = Z(:, i);
    R(:,:,chan,i) = c;
  end
end


return

for i=1:size(images, 4),
recon = reshape(fills(:,:,1:3,i), [512,512,3]);       
imwrite(recon, sprintf('/tmp/recon-%04d.jpg', i - 1));
end